#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>

struct TSeller
{
	char szName[50];
	float fMinPrice;
	struct TSeller *Next;
} SELLER;

struct TBuyer
{
	char szName[50];
	float fMaxPrice;
	struct TBuyer *Next;
} BUYER;


const char szEnd[] = "0 END\n";
const char szBuy[] = "buy";
const char szSell[] = "sell";

char szCurIssuer[100], szBuf[500], szTempBuf[100], szTempBuf2[100], *szCur, *szTemp;
struct SELLER *TopSeller;
struct BUYER *TopBuyer;


int GetHeadWord(const char *szSrc, char *szDest)
{
	const char *szTemp = szSrc;
	
	while ((*szTemp != '\0') && (*szTemp != '\n') && (*szTemp != ' '))
	{
		*(szDest++) = *(szTemp++);
	}
	
	*szDest = '\0';
	
	return (szTemp -szSrc);
}

void ReleaseSellers()
{
	struct SELLER *TempSeller;
	
	while (TopSeller != NULL)
	{
		TempSeller = TopSeller->Next;
		free(TopSeller);
		TopSeller = TempSeller;
	}
}

void ReleaseBuyers()
{
	struct BUYER *TempBuyer;
	
	while (TopBuyer != NULL)
	{
		TempBuyer = TopBuyer->Next;
		free(TopBuyer);
		TopBuyer = TempBuyer;
	}
}

int main(int argc, char *argv[])
{
	struct BUYER *TempBuyer;
	struct SELLER *TempSeller;
	
	while (fgets(szBuf, 500, stdin) != NULL)
	{
		szCur = szBuf;
		
		if (!strcmp(szBuf, szEnd))
		{
			return 0;
		}
		
		szCur += 1 +GetHeadWord(szCur, szTempBuf);
		strtol(szTempBuf, &szTemp, 10);
		if ((szTemp != NULL) && (*szTemp != '\0'))
		{
			ReleaseSellers();
			ReleaseBuyers();
			
			szCur += 1 +GetHeadWord(szCur, szCurIssuer);
		}
		else
		{
			szCur += 1 +GetHeadWord(szCur, szTempBuf2);

			if (!strcmp(szTempBuf2, szBuy))
			{
				TempBuyer = (BUYER*)malloc(sizeof(BUYER));
				strcpy(TempBuyer->szName, szTempBuf);
			}
			else
			{
				TempSeller = (SELLER*)malloc(sizeof(SELLER));
				strcpy(TempSeller->szName, szTempBuf);
			}
			
			szCur += 1 +GetHeadWord(szCur, szTempBuf);
			
			if (!strcmp(szTempBuf2, szBuy))
			{
				TempBuyer->fMaxPrice = atof(szTempBuf);
				TempBuyer->Next = TopBuyer;
				TopBuyer = TempBuyer;
			}
			else
			{
				TempSeller->fMinPrice = atof(szTempBuf);
				TempSeller->Next = TopSeller;
				TopSeller = TempSeller;
			}
			
		}
	}
	
	return 0;
}

